# Class Deprecated

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.Deprecated

All Implemented Interfaces:
  `Cloneable, Node`

public final class Deprecated extends Attribute
This class is derived from Attribute and denotes that this is a deprecated method. It is instantiated from the Attribute.readAttribute() method.

    Deprecated_attribute {
        u2 attribute_name_index;
        u4 attribute_length;
    }

See Also:
  - `Attribute`
  - JVM Specification: The Deprecated Attribute

- ## Field Summary

  ### Fields inherited from class Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Deprecated(int nameIndex, int length, byte[] bytes, ConstantPool constantPool)`
  Constructs a Deprecated attribute.
  `Deprecated(Deprecated c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  Creates a deep copy of this attribute.
  `byte[]`
  `getBytes()`
  Gets the data bytes.
  `void`
  `setBytes(byte[] bytes)`
  Sets the data bytes.
  `String`
  `toString()`

  ### Methods inherited from class Attribute

  `addAttributeReader, addAttributeReader, clone, dump, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Deprecated

    public Deprecated(Deprecated c)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.
    Parameters:
      `c` - Source to copy.

  - ### Deprecated

    public Deprecated(int nameIndex, int length, byte[] bytes, ConstantPool constantPool)
    Constructs a Deprecated attribute.
    Parameters:
      `nameIndex` - Index in constant pool to CONSTANT_Utf8.
      `length` - JVM Specification: "The value of the attribute_length item must be zero.".
      `bytes` - Attribute contents.
      `constantPool` - Array of constants.
    See Also:
      - JVM Specification: The Deprecated Attribute

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. That is, the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object.

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Description copied from class: `Attribute`
    Creates a deep copy of this attribute.
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute.

  - ### getBytes

    public byte[] getBytes()
    Gets the data bytes.
    Returns:
      data bytes.

  - ### setBytes

    public void setBytes(byte[] bytes)
    Sets the data bytes.
    Parameters:
      `bytes` - the raw bytes that represents this byte array.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      attribute name.